/* This file has been automatically generated */

/* Copyright (C) 2007, 2008 Free Software Foundation, Inc. */

/* This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef PDF_H
#define PDF_H
#ifdef __cplusplus
extern "C" {
#endif
/* BEGIN PUBLIC */

/* Macro to access the global state of the library pdf_globals */
#define PDF_GLOBALS extern struct pdf_globals_s pdf_globals;

/* This structure contains global data used by the library. A variable
   of this type, called `pdf_globals', is defined in pdf.c. The
   contents of this structure are initialized in the `pdf_init'
   function. */

struct pdf_globals_s
{

};


/* API of the library */

int pdf_init (void);
int pdf_finish (void);

/* END PUBLIC */
/* BEGIN PUBLIC */

#include <stdio.h>  /* Included again for the public header */

#define PDF_ERROR_LIST                                                  \
  ERROR_ENTRY (PDF_ERROR,       "error"),                               \
  ERROR_ENTRY (PDF_EBADDATA,    "invalid or bad arguments"),            \
  ERROR_ENTRY (PDF_ENOMEM,      "insufficient memory"),                 \
  ERROR_ENTRY (PDF_EEOF,        "end of file"),                         \
  ERROR_ENTRY (PDF_EDIVBYZERO,  "divison by zero"),                     \
  ERROR_ENTRY (PDF_ENONODE,     "no node found"),                       \
  ERROR_ENTRY (PDF_EINVRANGE,   "invalid range"),                       \
  ERROR_ENTRY (PDF_ETEXTENC,    "error in text encoding"),              \
  ERROR_ENTRY (PDF_ENOMATCH,    "no matching found"),                   \
  ERROR_ENTRY (PDF_EBADTEXT,    "invalid text format"),                 \
  ERROR_ENTRY (PDF_EBADPERMS,   "not enough permissions"),              \
  ERROR_ENTRY (PDF_EBADNAME,    "invalid path name"),                   \
  ERROR_ENTRY (PDF_EAGAIN,      "operation can't be performed now, maybe later"), \
  ERROR_ENTRY (PDF_ENOSPC,      "no space left on device"),             \
  ERROR_ENTRY (PDF_EBADCONTEXT, "text module global context not initialized"),    \
  ERROR_ENTRY (PDF_ENOTEMPTY,   "operation requires some entity be empty"), \
  ERROR_ENTRY (PDF_ENINPUT,     "filter needs more input"),             \
  ERROR_ENTRY (PDF_ENOUTPUT,    "filter needs more output room"),       \
  ERROR_ENTRY (PDF_EEXIST,      "already exists"),                      \
  ERROR_ENTRY (PDF_EOPENED,     "file is opened"),                      \
  ERROR_ENTRY (PDF_ECLOSED,     "file is closed"),                      \
  ERROR_ENTRY (PDF_EOVERFLOW,   "Input is too large"),                  \
  ERROR_ENTRY (PDF_EUNDERFLOW,  "Input is too small"),                  \
  ERROR_ENTRY (PDF_EMTOOBIG,    "/FunctionType 0: input dim too high (<= 12)"), \
  ERROR_ENTRY (PDF_EBADSAMPLES, "/FunctionType 0: error while reading sample table"), \
  ERROR_ENTRY (PDF_EBADAESKEY,  "the size of an AES  key should be a multiple of 16"), \
  ERROR_ENTRY (PDF_EBADV2KEY,   "a V2 key should be at least 40 bits long"), \
  ERROR_ENTRY (PDF_EINVOP,      "invalid operation"),                        \
  ERROR_ENTRY (PDF_EBADOP,      "/FunctionType 4: Unknown operator"),                 \
  ERROR_ENTRY (PDF_EMISSBODY,   "/FunctionType 4: Missing body conditional"),         \
  ERROR_ENTRY (PDF_ENOWRAP,     "/FunctionType 4: Code should be wrapped by braces"), \
  ERROR_ENTRY (PDF_ETOODEPTH,   "/FunctionType 4: Exceeded the max depth level"),     \
  ERROR_ENTRY (PDF_EMISSIF,     "/FunctionType 4: Missing if/ifelse operator"),       \
  ERROR_ENTRY (PDF_EBADTYPE,    "/FunctionType 4: Bad type"),         \
  ERROR_ENTRY (PDF_EMATH,       "/FunctionType 4: Math error"),       \
  ERROR_ENTRY (PDF_ETYPE0,      "/FunctionType 0: Error"),            \
  ERROR_ENTRY (PDF_ETYPE2,      "/FunctionType 2: Error"),            \
  ERROR_ENTRY (PDF_ETYPE3,      "/FunctionType 3: Error"),            \
  ERROR_ENTRY (PDF_ETYPE4,      "/FunctionType 4: Error")

#define ERROR_ENTRY(id,string) id
enum pdf_status_e
{
  PDF_OK = 0,
  PDF_ERROR_LIST,
  PDF_STATUS_ITEMS
};
#undef ERROR_ENTRY

typedef enum pdf_status_e pdf_status_t;

extern const char * pdf_error_stlist [];

/* Print a message with `fprintf (fd, FORMAT, ...)';
   if status is nonzero, print the corresponding message. */
extern void pdf_error (const pdf_status_t status, FILE * fd, const char *format, ...);

/* Print the message corresponding to 'status' to stderr
 * followed by 'str'.
 */
extern void pdf_perror (const pdf_status_t status, const char *str);


/* END PUBLIC */
/* BEGIN PUBLIC */
#include <sys/types.h> /* for off_t */
#include <stdint.h> /* for uint32_t and others, from gnulib */

#include <sys/param.h> /* for determining system types (mostly BSD) */

#ifdef HAVE_INLINE
#define INLINE inline
#else
#define INLINE
#endif /* HAVE_INLINE */

/* Host dependent definitions to be used */

#if defined _WIN32 || defined __WIN32__
 #define PDF_HOST_WIN32
 #include <windows.h>
#endif

#if defined(BSD)
 #define PDF_HOST_BSD
#endif

#define PDF_TRUE 1
#define PDF_FALSE 0

#define PDF_MIN(i1, i2) \
  (((i1) < (i2)) ? (i1) : (i2))

#define PDF_MAX(i1, i2) \
  (((i1) > (i2)) ? (i1) : (i2))

/* Definitions used in the operations of the  pdf_i64_t type*/
#define PDF_I32_MAX 2147483647;
#define PDF_I32_DIV 2147483648;
#define PDF_U32_MAX 4294967295;
#define PDF_U16_MAX 65535;
#define PDF_U16_DIV 65536;
#define PDF_U8_MAX 255;
#define PDF_U8_DIV 256;


/* A variable of type `pdf_off_t' contain a byte-offset relative to
   the beginning of a stream object. 

   Please be careful manipulating `pdf_off_t' values. Its value is
   assured to be a signed scalable one, but its size may be wider than
   a long. */
#define NO_POS -1
typedef off_t pdf_off_t;

/* Memory indexes (size_t) */
typedef size_t pdf_size_t;

/* PDF manages bytes with values in the range 0-255 */
typedef unsigned char pdf_char_t;

/* 32-bit unsigned integer */
typedef uint32_t pdf_u32_t;

/* 32-bit signed integer */
typedef int32_t pdf_i32_t;

/* 16-bit unsigned integer */
typedef uint16_t pdf_u16_t;

/* 16-bit signed integer */
typedef int16_t pdf_i16_t;

/* 8-bit unsigned integer */
typedef unsigned char pdf_u8_t;

/* 8-bit signed integer */
typedef char pdf_i8_t;

/* Boolean type */
typedef unsigned char pdf_bool_t;

/********************** Simple memory buffers **************************/

struct pdf_buffer_s
{
  pdf_char_t *data;    /* Buffer contents */
  pdf_size_t size;     /* Size of the buffer in octects */
  pdf_size_t rp;       /* Read pointer */
  pdf_size_t wp;       /* Write pointer */
};

typedef struct pdf_buffer_s *pdf_buffer_t;

pdf_buffer_t pdf_buffer_new (pdf_size_t size);
pdf_status_t pdf_buffer_destroy (pdf_buffer_t buffer);

pdf_bool_t pdf_buffer_full_p (pdf_buffer_t buffer);
pdf_bool_t pdf_buffer_eob_p (pdf_buffer_t buffer);

pdf_status_t pdf_buffer_resize (pdf_buffer_t buffer, pdf_size_t newsize);
pdf_status_t pdf_buffer_rewind (pdf_buffer_t buffer);

/********************** progress monitors **************************/

typedef pdf_status_t (*pdf_pm_begin_operation_fn_t) (void *client_data);
typedef pdf_status_t (*pdf_pm_end_operation_fn_t) (void *client_data);
typedef pdf_status_t (*pdf_pm_get_duration_fn_t) (void *client_data, void *duration);
typedef pdf_status_t (*pdf_pm_set_duration_fn_t) (void *client_data, void *duration);
typedef pdf_status_t (*pdf_pm_get_current_value_fn_t) (void *client_data, void *duration);
typedef pdf_status_t (*pdf_pm_set_current_value_fn_t) (void *client_data, void *duration);
typedef pdf_status_t (*pdf_pm_set_text_fn_t) (void *client_data, void *text);

struct pdf_pm_s
{
  pdf_pm_begin_operation_fn_t begin_operation_fn;
  pdf_pm_end_operation_fn_t end_operation_fn;
  pdf_pm_get_duration_fn_t get_duration_fn;
  pdf_pm_set_duration_fn_t set_duration_fn;
  pdf_pm_get_current_value_fn_t get_current_value_fn_t;
  pdf_pm_set_current_value_fn_t set_current_value_fn_t;
  pdf_pm_set_text_fn_t set_text_fn;
};

/********************** 64-bit type built-in support **************************/

#if defined(int64_t) && !defined(PDF_FORCE_BIGNUMS)
#define PDF_USE_BUILTIN_64BIT_SUPPORT
#endif

#ifndef PDF_USE_BUILTIN_64BIT_SUPPORT
/*Definition of internal structure of the pdf_i64_t type*/
struct pdf_i64_s
{
  pdf_i32_t   high;
  pdf_u32_t low;
};

typedef struct pdf_i64_s pdf_i64_t;

#else

/* 64-bit signed integer supported by system*/
typedef int64_t pdf_i64_t;
#endif


#ifndef PDF_USE_BUILTIN_64BIT_SUPPORT

/*Create and initialise a new pdf_i64_t variable*/
pdf_i64_t pdf_i64_new(const pdf_i32_t high, const pdf_u32_t low);

/*Assign values to a pdf_i64_t pointer*/
void 
pdf_i64_assign (pdf_i64_t *bignum, const pdf_i32_t high, const pdf_u32_t low,
		pdf_status_t *p_status);

/*Quick version of assignment in which only the lowest siginificant
  part is taken into account*/
void 
pdf_i64_assign_quick(pdf_i64_t *bignum, const pdf_i32_t value, pdf_status_t *p_status);


/*Copy one pdf_i64_t variable into another*/
void 
pdf_i64_copy(const pdf_i64_t orig, pdf_i64_t *copy, pdf_status_t *p_status);

/*Add two pdf_i64_t variables*/
void 
pdf_i64_add(pdf_i64_t *dest, const pdf_i64_t addend1, const pdf_i64_t addend2, 
	    pdf_status_t *p_status);


/*Compare two pdf_i64_t variables*/
int pdf_i64_cmp(const pdf_i64_t number_1, const pdf_i64_t number_2);


/*Calculate the absolute value of a pdf_i64_t variable*/
void 
pdf_i64_abs(pdf_i64_t *dest, const pdf_i64_t number, pdf_status_t *p_status);

/*Negate a pdf_i64_t type variable*/
void 
pdf_i64_neg(pdf_i64_t *dest, const pdf_i64_t number, pdf_status_t *p_status);

/*Subtract two pdf_i64_t variables*/
void 
pdf_i64_subtraction(pdf_i64_t *dest, const pdf_i64_t minuend, const pdf_i64_t subtrahend,
		    pdf_status_t *p_status);


/*Multiply two pdf_i64_t variables*/
void 
pdf_i64_mult(pdf_i64_t *dest, const pdf_i64_t factor_1, const pdf_i64_t factor_2, 
	     pdf_status_t *p_status);


/*Division between two pdf_i64_t type variables*/
void 
pdf_i64_div(pdf_i64_t *dest, const pdf_i64_t dividend, const pdf_i64_t divisor, 
	    pdf_status_t *p_status);

/*Modulus division between two pdf_i64_t variables*/
void 
pdf_i64_mod(pdf_i64_t *dest, const pdf_i64_t dividend, const pdf_i64_t divisor, 
	    pdf_status_t *p_status);


/* Add a pdf_i64_t and a pdf_i32_t */
void 
pdf_i64_add_i32(pdf_i64_t *dest, const pdf_i64_t addend1, const pdf_i32_t addend2, 
		pdf_status_t *p_status);

/* Compare a pdf_i64_t and a pdf_i32_t */
int pdf_i64_cmp_i32(const pdf_i64_t number_1, const pdf_i32_t number_2);

/* Subtract a pdf_i64_t and a pdf_i32_t variable */
void 
pdf_i64_subtraction_i32_min(pdf_i64_t *dest, const pdf_i32_t minuend, const pdf_i64_t subtrahend,
			    pdf_status_t *p_status);
void 
pdf_i64_subtraction_i32_sub(pdf_i64_t *dest, const pdf_i64_t minuend, const pdf_i32_t subtrahend,
			    pdf_status_t *p_status);

/* Multiply a pdf_i64_t and a pdf_i32_t */
void 
pdf_i64_mult_i32(pdf_i64_t *dest, const pdf_i64_t factor_1, const pdf_i32_t factor_2,
		 pdf_status_t *p_status);

/* Divide a pdf_i64_t and a pdf_i32_t */
void 
pdf_i64_div_i32_dividend(pdf_i64_t *dest, const pdf_i32_t dividend, const pdf_i64_t divisor, 
			 pdf_status_t *p_status);
void 
pdf_i64_div_i32_divisor(pdf_i64_t *dest, const pdf_i64_t dividend, const pdf_i32_t divisor, 
			pdf_status_t *p_status);


/* Modulus between a pdf_i64_t and a pdf_i32_t */
void 
pdf_i64_mod_i32_dividend(pdf_i64_t *dest, const pdf_i32_t dividend, const pdf_i64_t divisor, 
			 pdf_status_t *p_status);
void 
pdf_i64_mod_i32_divisor(pdf_i64_t *dest, const pdf_i64_t dividend, const pdf_i32_t divisor, 
			pdf_status_t *p_status);


/* Get number as pdf_i32_t. Note that if the pdf_i64_t variable is holding a 
 * number which can't be represented in 32bits, the result is undefined... so
 * use it with caution. */
pdf_i32_t
pdf_i64_to_i32(const pdf_i64_t bignum);


#else /*else of the PDF_USE_BUILTIN_64BIT_SUPPORT*/

/*Create and initialise a new pdf_i64_t variable*/
#define pdf_i64_new(high, low) ((((pdf_i64_t)high)<<32) + low)	

#define pdf_i64_assign(bignum, high, low, p_status)	\
  do{ \
    if (bignum == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
	*bignum = 0;				\
	*bignum = (((pdf_i64_t)high)<<32);	\
	*bignum = *bignum + low;		\
      }						\
  }while(0)
   

/*Quick version of assignment in which only the lowest siginificant
  part is taken into account*/
#define pdf_i64_assign_quick(bignum, value, p_status) \
  do{ \
    if (bignum == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
	*bignum = value;			\
      }						\
  }while(0)

/*Copy one pdf_i64_t variable into another*/
#define pdf_i64_copy(orig, copy, p_status) \
  do{\
    if (copy == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
	*copy = orig;				\
      }						\
  }while(0)

/*Add two pdf_i64_t variables*/
#define pdf_i64_add(dest, addend1, addend2, p_status) \
  do{\
    if (dest == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
	*dest = addend1 + addend2;		\
      }						\
  }while(0)

/*Compare two pdf_i64_t variables*/
#define pdf_i64_cmp(number_1, number_2) \
  ((number_1 > number_2) ? 1 : ((number_1 < number_2) ? -1 : 0))

/*Calculate the absolute value of a pdf_i64_t variable*/
#define pdf_i64_abs(dest, number, p_status) \
  do{\
    if (dest == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
	*dest = abs(number);			\
      }						\
  }while(0)
    
/*Negate a pdf_i64_t type variable*/
#define pdf_i64_neg(dest, number, p_status) \
  do{\
    if (dest == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
	*dest = -number;			\
      }						\
  }while(0)

/*Subtract two pdf_i64_t variables*/
#define pdf_i64_subtraction(dest, minuend, subtrahend, p_status) \
  do{\
    if (dest == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
	*dest = minuend - subtrahend;		\
      }						\
  }while(0)

/*Multiply two pdf_i64_t variables*/
#define pdf_i64_mult(dest, factor_1, factor_2, p_status) \
  do{\
    if (dest == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
	*dest = factor_1 * factor_2;		\
      }						\
  }while(0)

/*Division between two pdf_i64_t type variables*/
#define pdf_i64_div(dest, dividend, divisor, p_status) \
  do{\
    if (dest == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
      }						\
    *dest = dividend/divisor;\
  }while(0)

/*Modulus division between two pdf_i64_t variables*/
#define pdf_i64_mod(dest, dividend, divisor, p_status) \
  do{\
    if (dest == NULL)				\
      {						\
	*p_status =  PDF_ERROR;			\
      }						\
    else					\
      {						\
	*p_status =  PDF_OK;			\
	*dest = dividend%divisor;		\
      }						\
  }while(0)


/* Add a pdf_i64_t and a pdf_i32_t */
#define pdf_i64_add_i32 pdf_i64_add

/* Compare a pdf_i64_t and a pdf_i32_t */
#define pdf_i64_cmp_i32 pdf_i64_cmp

/* Subtract a pdf_i64_t and a pdf_i32_t variable */
#define pdf_i64_subtraction_i32_min pdf_i64_subtraction
#define pdf_i64_subtraction_i32_sub pdf_i64_subtraction

/* Multiply a pdf_i64_t and a pdf_i32_t */
#define pdf_i64_mult_i32 pdf_i64_mult

/* Divide a pdf_i64_t and a pdf_i32_t */
#define pdf_i64_div_i32_dividend pdf_i64_div
#define pdf_i64_div_i32_divisor pdf_i64_div


/* Modulus between a pdf_i64_t and a pdf_i32_t */
#define pdf_i64_mod_i32_dividend pdf_i64_mod
#define pdf_i64_mod_i32_divisor pdf_i64_mod


/* Get number as pdf_i32_t. Note that if the pdf_i64_t variable is holding a 
 * number which can't be represented in 32bits, the result is undefined... so
 * use it with caution. */
#define pdf_i64_to_i32(bignum) bignum

#endif

/* END PUBLIC */
/* BEGIN PUBLIC */

/* Constants */

#define PDF_PI M_PI

/* Data types */

typedef float pdf_real_t;

struct pdf_point_s
{
  pdf_real_t h;
  pdf_real_t v;
};

typedef struct pdf_point_s *pdf_point_t;

struct pdf_matrix_s
{
  pdf_real_t a;
  pdf_real_t b;
  pdf_real_t c;
  pdf_real_t d;
  pdf_real_t h;
  pdf_real_t v;
};

typedef struct pdf_matrix_s *pdf_matrix_t;

struct pdf_quad_s
{
  pdf_real_t t1;
  pdf_real_t tr;
  pdf_real_t b1;
  pdf_real_t br;
};

typedef struct pdf_quad_s *pdf_quad_t;

struct pdf_rect_s
{
  pdf_real_t left;
  pdf_real_t top;
  pdf_real_t right;
  pdf_real_t bottom;
};

typedef struct pdf_rect_s *pdf_rect_t;

/* Function prototypes */

pdf_real_t pdf_fp_sqrt (pdf_real_t op);
pdf_real_t pdf_fp_sin (pdf_real_t op);
pdf_real_t pdf_fp_cos (pdf_real_t op);
pdf_real_t pdf_fp_atan2 (pdf_real_t op1, pdf_real_t op2);
pdf_real_t pdf_fp_exp (pdf_real_t op);
pdf_real_t pdf_fp_abs (pdf_real_t op);
pdf_real_t pdf_fp_log10 (pdf_real_t op);
pdf_real_t pdf_fp_log (pdf_real_t op);
pdf_real_t pdf_fp_floor (pdf_real_t op);
pdf_real_t pdf_fp_ceil (pdf_real_t op);

/* END PUBLIC */
/* BEGIN PUBLIC */

void *pdf_alloc (const pdf_size_t size);
void pdf_dealloc (const void *pointer);
void *pdf_realloc (const void *pointer, const pdf_size_t size);

/* END PUBLIC */
/* BEGIN PUBLIC */
#include <stdbool.h>
/* END PUBLIC */
/* BEGIN PUBLIC */

/* List module API implementation */

/* Data types */

#define PDF_LIST_ITERATOR_SIZE 12

struct pdf_list_s
{
  void *gl_list;
  pdf_bool_t allow_duplicates;
};

struct pdf_list_iterator_s
{
  void *gl_iterator[PDF_LIST_ITERATOR_SIZE];
};

struct pdf_list_node_s
{
  void *gl_node;
};

typedef struct pdf_list_s pdf_list_t;
typedef struct pdf_list_node_s pdf_list_node_t;
typedef struct pdf_list_iterator_s pdf_list_iterator_t;

typedef bool (*pdf_list_element_equals_fn_t) (const void *elt1, const void *elt2);
typedef pdf_size_t (*pdf_list_element_hashcode_fn_t) (const void *elt);
typedef void (*pdf_list_element_dispose_fn_t) (const void *elt);
typedef int (*pdf_list_element_compar_fn_t) (const void *elt1, const void *elt2);


/* END PUBLIC */
/* BEGIN PUBLIC */

/* Creation and destruction functions */

pdf_status_t pdf_list_new (pdf_list_element_equals_fn_t equals_fn,
                              pdf_list_element_dispose_fn_t dispose_fn,
                              const pdf_bool_t allow_duplicates,
                              pdf_list_t *list);

pdf_status_t pdf_list_destroy (pdf_list_t list);

/* Property management functions */

pdf_size_t pdf_list_size (const pdf_list_t list);

/* Element searching functions */

pdf_status_t pdf_list_search (const pdf_list_t list, const void* element, pdf_list_node_t *node);
pdf_status_t pdf_list_search_from (const pdf_list_t list, const pdf_size_t start_index,
                                   const void* element, pdf_list_node_t *node);
pdf_status_t pdf_list_search_from_to (const pdf_list_t list,
                                      const pdf_size_t start_index,
                                      const pdf_size_t end_index,
                                      const void* element,
                                      pdf_list_node_t *node);
pdf_status_t pdf_list_next_node (const pdf_list_t list, const pdf_list_node_t node, pdf_list_node_t *next);
pdf_status_t pdf_list_previous_node (const pdf_list_t list, const pdf_list_node_t node, pdf_list_node_t *prev);
pdf_status_t pdf_list_indexof (const pdf_list_t list, const void *element, pdf_size_t *position);
pdf_status_t pdf_list_indexof_from (const pdf_list_t list, const pdf_size_t start_index,
                                    const void *element, pdf_size_t *position);
pdf_status_t pdf_list_indexof_from_to (const pdf_list_t list, const pdf_size_t start_index,
                                       const pdf_size_t end_index, const void* element,
                                       pdf_size_t *position);

/* Element setting and getting functions */

const void * pdf_list_node_value (const pdf_list_t list, const pdf_list_node_t node);
const pdf_status_t pdf_list_get_at (const pdf_list_t list, const pdf_size_t position, void **value);
pdf_status_t pdf_list_set_at (pdf_list_t list, const pdf_size_t position,
                              const void* element, pdf_list_node_t *node);

/* Element addition and removal functions */

pdf_status_t pdf_list_add_first (pdf_list_t list, const void* element, pdf_list_node_t *node);
pdf_status_t pdf_list_add_last (pdf_list_t list, const void* element, pdf_list_node_t *node);
pdf_status_t pdf_list_add_at (pdf_list_t list, const pdf_size_t position,
                              const void* element, pdf_list_node_t *node);
pdf_status_t pdf_list_remove_node (pdf_list_t list, const pdf_list_node_t node);
pdf_status_t pdf_list_remove_at (pdf_list_t list, const pdf_size_t position);
pdf_status_t pdf_list_remove (pdf_list_t list, const void * element);

/* Sorted list functions */

pdf_status_t
pdf_list_sorted_add (pdf_list_t list, pdf_list_element_compar_fn_t compar_fn,
                     const void* element, pdf_list_node_t * element_node);

pdf_status_t
pdf_list_sorted_remove (pdf_list_t list, pdf_list_element_compar_fn_t compar_fn,
                        const void * element);

pdf_status_t
pdf_list_sorted_search (const pdf_list_t list, pdf_list_element_compar_fn_t compar_fn,
                        const void* element, pdf_list_node_t *node);

pdf_status_t
pdf_list_sorted_search_from_to (const pdf_list_t list,
                                pdf_list_element_compar_fn_t compar_fn,
                                const pdf_size_t start_index, const pdf_size_t end_index,
                                const void* element, pdf_list_node_t *node);

pdf_status_t
pdf_list_sorted_indexof (const pdf_list_t list,
                         pdf_list_element_compar_fn_t compar_fn,
                         const void* element, pdf_size_t *position);

pdf_status_t
pdf_list_sorted_indexof_from_to (const pdf_list_t list,
                                 pdf_list_element_compar_fn_t compar_fn,
                                 const pdf_size_t start_index, const pdf_size_t end_index,
                                 const void* element, pdf_size_t *position);

/* Element iterator functions */

pdf_status_t pdf_list_iterator (const pdf_list_t list, pdf_list_iterator_t *itr);
pdf_status_t pdf_list_iterator_from_to (const pdf_list_t list,
                                        const pdf_size_t start_index,
                                        const pdf_size_t end_index,
                                        pdf_list_iterator_t *itr);
pdf_status_t pdf_list_iterator_next (pdf_list_iterator_t *iterator,
                                     const void **element_pointer,
                                     pdf_list_node_t *node_pointer);
pdf_status_t pdf_list_iterator_free (pdf_list_iterator_t *iterator);


/* END PUBLIC */
/* BEGIN PUBLIC */
typedef void (*pdf_hash_element_dispose_fn_t) (const void *elt);
/* END PUBLIC */
/* BEGIN PUBLIC */

#define PDF_HASH_ITERATOR_SIZE 12

typedef void (*pdf_hash_key_dispose_fn_t) (const void *key);

struct pdf_hash_s
{
  /* Both are gl_lists */
  void *elements, *keys;
};

struct pdf_hash_iterator_s
{
  void *gl_itr[PDF_HASH_ITERATOR_SIZE];
};

typedef struct pdf_hash_s pdf_hash_t;
typedef struct pdf_hash_iterator_s pdf_hash_iterator_t;


/* Creating and Destroying Hash Tables */

pdf_status_t
pdf_hash_new (pdf_hash_key_dispose_fn_t dispose_key_fn, pdf_hash_t *table);

pdf_status_t
pdf_hash_destroy (pdf_hash_t table);


/* Hash Table properties */

pdf_size_t
pdf_hash_size (const pdf_hash_t table);


/* Working with keys */

pdf_bool_t
pdf_hash_key_p (const pdf_hash_t table, const char *key);

pdf_status_t
pdf_hash_rename (pdf_hash_t table, const char *key, const char *new_key);


 /* Adding and removing elements */

pdf_status_t
pdf_hash_add (pdf_hash_t table, const char *key, const void *element,
              pdf_hash_element_dispose_fn_t disp_fn);

pdf_status_t
pdf_hash_remove (pdf_hash_t table, const char *key);


/* Searching elements */

pdf_status_t
pdf_hash_get (const pdf_hash_t table, const char *key, const void **elem_pointer);


/* Working with iterators  */

pdf_status_t
pdf_hash_iterator_new (const pdf_hash_t table, pdf_hash_iterator_t *iterator);

pdf_status_t
pdf_hash_iterator_next (pdf_hash_iterator_t iterator, const char **key);

pdf_status_t
pdf_hash_iterator_destroy (pdf_hash_iterator_t iterator);

/* Basic dispose functions */

void
pdf_hash_element_dealloc_fn (const void * elt);

void
pdf_hash_key_dealloc_fn (const void * elt);



/* END PUBLIC */
/* BEGIN PUBLIC */

typedef struct pdf_time_s *pdf_time_t;


/* A variable of type pdf_time_span_t represents a span of time. */
typedef pdf_i64_t pdf_time_span_t;

/* This structure holds information about a specific time represented in
 *  calendar items: years, months, days, day of week, hours, minutes, seconds 
 *  and the relative offset with GMT. */
struct pdf_time_cal_s {
  /* A year number. */
  pdf_u32_t  year;
  /* A month number. The valid range is 1..12. */
  pdf_u32_t month;
  /* A day number. The valid range is 1..31. */
  pdf_u32_t day;
  /* Day of the week. The valid range is 1..7 (Monday to Sunday). */
  pdf_u32_t dow;
  /* An hour. The valid range is 0..23. */
  pdf_u32_t hour;
  /* A minute. The valid range is 0..59. */
  pdf_u32_t minute;
  /* A second. The valid range is 0..59. */
  pdf_u32_t second;
  /* A GMT offset, in seconds WEST of GMT */
  pdf_i32_t  gmt_offset;
};


/* This structure holds information about a time span represented in calendar
 *  items: years, months, days, hours, minutes and seconds. */
struct pdf_time_cal_span_s {
  pdf_bool_t sign;
  pdf_u32_t years;
  pdf_u32_t months;
  pdf_u32_t days;
  pdf_u32_t hours;
  pdf_u32_t minutes;
  pdf_u32_t seconds;
};


/* Enumeration containing the several supported time formats used to convert a
 *  time to a string representation or to parse a time from a string
 *  representation. */
enum pdf_time_format_e {
  PDF_TIME_FORMAT_PDF,
  PDF_TIME_FORMAT_ISO_8601,
  PDF_TIME_FORMAT_UTC_ASN1,
  PDF_TIME_FORMAT_GENERALIZED_ASN1
};


/* --------------------- Time Module Initialization ------------------------- */

/* Initialize Time module. Warning! Not thread-safe, must be used only once when
 *  the program starts. It will be in charge of detecting currently configured
 *  time zone (GMT offset) and so on. */
pdf_status_t
pdf_time_init(void);


/* --------------------- Time Creation and Destruction ---------------------- */

/* Create new pdf_time_t object */
pdf_status_t
pdf_time_new (pdf_time_t *time);

/* Duplicate pdf_time_t object */
pdf_time_t
pdf_time_dup (const pdf_time_t orig);

/* Destroy pdf_time_t object */
pdf_status_t
pdf_time_destroy (pdf_time_t time_var);


/* ------------------------- Managing Time Values --------------------------- */

/* Copy the contents of a given pdf_time_t object */
pdf_status_t
pdf_time_copy (const pdf_time_t orig,
               pdf_time_t copy);

/* Clear contents of the pdf_time_t object */
pdf_status_t
pdf_time_clear (pdf_time_t time_var);


/* Set time value with a 32-bit unsigned integer */
pdf_status_t
pdf_time_set_from_u32 (pdf_time_t time_var,
                       pdf_u32_t seconds);


/* Set time value with a pdf_i64_t variable */
pdf_status_t
pdf_time_set_from_i64 (pdf_time_t time_var,
                       pdf_i64_t  seconds);


#ifdef PDF_HOST_WIN32
  /* Windows-specific function to set the time with a pdf_i64_t */
  pdf_status_t
  pdf_time_w32_set_from_filetime (pdf_time_t time_var,
                                  const FILETIME *p_filetime);
#endif


/* Add the time span represented by cal_span to the text object */
pdf_status_t
pdf_time_add_cal_span (pdf_time_t time_var,
                       const struct pdf_time_cal_span_s *p_cal_span);

/* Substract the time span represented by cal_span from the text object */
pdf_status_t
pdf_time_sub_cal_span (pdf_time_t time_var,
                       const struct pdf_time_cal_span_s *p_cal_span);

/* Add the time span contained in time_span to time. */
pdf_status_t
pdf_time_add_span (pdf_time_t time_var,
                   const pdf_time_span_t time_span);

/* Subtract the time span contained in time_span to time. */
pdf_status_t
pdf_time_sub_span (pdf_time_t time_var,
                   const pdf_time_span_t time_span);

/* Fill local_cal with the local calendar time of object. */
pdf_status_t
pdf_time_get_local_cal (const pdf_time_t time_var,
                        struct pdf_time_cal_s *p_local_cal);

/* Get the UTC calendar time of a given time variable. */
pdf_status_t
pdf_time_get_utc_cal (const pdf_time_t time_var,
                      struct pdf_time_cal_s *p_utc_cal);

/* Set the value of a time variable to a given calendar time. */
pdf_status_t
pdf_time_from_cal (pdf_time_t time_var,
                   const struct pdf_time_cal_s *p_cal_time);

/* Set the local time offset of time to the one used by the operating system. */
pdf_status_t
pdf_time_set_local_offset (pdf_time_t time_var);



/* ----------------------- Getting Time Intervals --------------------------- */

/* Get time interval as Calendar Span */
pdf_status_t
pdf_time_diff_cal (const pdf_time_t time1,
                   const pdf_time_t time2,
                   struct pdf_time_cal_span_s *p_cal_span);

/* Get time interval as Span */
pdf_status_t
pdf_time_diff (const pdf_time_t time1,
               const pdf_time_t time2,
               pdf_time_span_t  *p_time_span);


/* ---------------------------- Time comparison ----------------------------- */

/* Compares two times. */
pdf_i32_t
pdf_time_cmp (const pdf_time_t time1,
              const pdf_time_t time2);


/* ---------------------- Time printing and parsing ------------------------- */

/* Create a string representation of a given time. */
pdf_char_t *
pdf_time_to_string (const pdf_time_t time_var,
                    const enum pdf_time_format_e time_format);


/* Get a string containing a time specification in some format and fill a time
 *  variable with the parsed values. */
pdf_status_t
pdf_time_from_string (pdf_time_t time_var,
                      const pdf_char_t *time_str,
                      const enum pdf_time_format_e time_format);


/* ---------------------- Getting the Current Time -------------------------- */

/* Set the value of object to the current local time used by the operating
 *  system. */
pdf_status_t
pdf_time_set_to_current_local_time (pdf_time_t time_var);


/* Set the value of object to the current UTC time used by the operating
 *  system. */
pdf_status_t
pdf_time_set_to_current_utc_time (pdf_time_t time_var);


/* ----------------- Time Span Creation and Destruction --------------------- */

/* Create new time span object */
pdf_time_span_t
pdf_time_span_new (void);

/* Duplicate time span object */
pdf_time_span_t
pdf_time_span_dup (const pdf_time_span_t span);


/* Destroy time span object */
pdf_status_t
pdf_time_span_destroy (pdf_time_span_t *p_span);


/* --------------------- Managing Time Span Values -------------------------- */

/* Set the value of a time span from a 64 bits signed number */
pdf_status_t
pdf_time_span_set (pdf_time_span_t *p_span,
                   const pdf_i32_t high_value,
                   const pdf_u32_t low_value);


/* Set the value of a time span from a 32 bits signed number. */
pdf_status_t
pdf_time_span_set_from_i32 (pdf_time_span_t *p_span,
                            const pdf_i32_t seconds);


/* Change sign of time span */
pdf_status_t
pdf_time_span_negate (pdf_time_span_t *p_span);


/* Add two time spans and store the result in another time span. */
pdf_status_t
pdf_time_span_add (const pdf_time_span_t span1,
                   const pdf_time_span_t span2,
                   pdf_time_span_t *p_result);

/* Copy the value of a time span into another time span. */
pdf_status_t
pdf_time_span_copy (const pdf_time_span_t orig,
                    pdf_time_span_t *p_dest);

/* Difference two time spans and store the result (maybe negative) into another
 *  time span. */
pdf_status_t
pdf_time_span_diff (const pdf_time_span_t span1,
                    const pdf_time_span_t span2,
                    pdf_time_span_t *p_result);

/* Get the value of a time span in seconds. */
pdf_i64_t
pdf_time_span_to_secs (const pdf_time_span_t span);


/* ------------------------- Time Span Comparison --------------------------- */

/* Compare two time spans */
pdf_i32_t
pdf_time_span_cmp (const pdf_time_span_t span1,
                   const pdf_time_span_t span2);


/* ---------------------- Calendar Spans Management ------------------------- */

/* Add two calendar spans. Since the calendar spans are relative (some years
 *  has more days than another) the calendar spans are first resolved from a
 *  base time. */
pdf_status_t
pdf_time_add_cal_span_with_base (const struct pdf_time_cal_span_s *p_span1,
                                 const struct pdf_time_cal_span_s *p_span2,
                                 const pdf_time_t base_time,
                                 struct pdf_time_cal_span_s *p_result);

/* Compare two calendar spans previously resolved with a given base time. */
pdf_i32_t
pdf_time_cal_span_cmp (const struct pdf_time_cal_span_s *p_span1,
                       const struct pdf_time_cal_span_s *p_span2,
                       const pdf_time_t base_time,
                       pdf_status_t *p_ret_code);

/* Compute the difference between two calendar spans relative to a given base
 *  time and store it in a given calendar span. */
pdf_status_t
pdf_time_cal_span_diff (const struct pdf_time_cal_span_s *p_span1,
                        const struct pdf_time_cal_span_s *p_span2,
                        const pdf_time_t base_time,
                        struct pdf_time_cal_span_s *p_result);


/* END PUBLIC */
/* BEGIN PUBLIC */


/* -------------------------- Text Data Types ------------------------------- */


/* Enumeration of supported UNICODE encodings */
enum pdf_text_unicode_encoding_e {
  PDF_TEXT_HE_TO_BE = -2, /* Delta to convert HE to BE */
  PDF_TEXT_HE_TO_LE = -1, /* Delta to convert HE to LE */
  PDF_TEXT_UTF8     =  0, /* UTF-8 encoding */
  PDF_TEXT_UTF16_BE,      /* Big Endian UTF-16 encoding */
  PDF_TEXT_UTF16_LE,      /* Little Endian UTF-16 encoding */
  PDF_TEXT_UTF16_HE,      /* Host Endian UTF-16 encoding (LE or BE) */
  PDF_TEXT_UTF32_BE,      /* Big Endian UTF-32 encoding */
  PDF_TEXT_UTF32_LE,      /* Little Endian UTF-32 encoding */
  PDF_TEXT_UTF32_HE,      /* Host Endian UTF-32 encoding (LE or BE) */
  PDF_TEXT_MAX_UNICODE_ENC
};


/* Enumeration of possible options when getting data in UNICODE format.
 *  Note that some options are only applicable to some UNICODE formats.
 *  Each of these enumerations is a Mask of Bits, so that multiple options 
 *  can be set at the same time */
enum pdf_text_unicode_options_e {
  PDF_TEXT_UNICODE_NO_OPTION       = 0x00,
  PDF_TEXT_UNICODE_WITH_BOM        = 0x01, /* UTF-8, UTF-16(L/B)E, UTF-32(L/B)E */
  PDF_TEXT_UTF16BE_WITH_LANGCODE   = 0x02, /* UTF16BE */
  PDF_TEXT_UNICODE_WITH_NUL_SUFFIX = 0x04  /* UTF-8, UTF-16(L/B)E, UTF-32(L/B)E */
};


/* Enumeration of supported filters in encoded text objects.
 *  Each of these enumerations is a Mask of Bits, so that multiple options 
 *  can be set at the same time */
enum pdf_text_filter_type_e {
  PDF_TEXT_FILTER_IDENTITY              = 0x00, /* No-op */
  PDF_TEXT_FILTER_LINE_ENDINGS          = 0x01, /* Normalize line endings */
  PDF_TEXT_FILTER_UPPER_CASE            = 0x02, /* Make all text uppercase */
  PDF_TEXT_FILTER_LOWER_CASE            = 0x04, /* Make all text lowercase */
  PDF_TEXT_FILTER_TITLE_CASE            = 0x08, /* Make all text titlecase */
  PDF_TEXT_FILTER_REMOVE_AMP            = 0x10, /* Remove all single & */
  PDF_TEXT_FILTER_NORM_WITH_FULL_WIDTH  = 0x20, /* Normalize with full width */
  PDF_TEXT_FILTER_REMOVE_LINE_ENDINGS   = 0x40  /* Replace line endings */
};


/* And reference to the structure (basic type to be used) */
typedef struct pdf_text_s *pdf_text_t;


/* Host Encoding Name Maximum Length */
#define PDF_TEXT_HENMAXL   32
/* Define structure to hold host encoding information. Probably a structure is
 *  the best option for this type, so that it's easy to update it in the future
 *  if needed */
typedef struct pdf_text_host_encoding_s {
  pdf_char_t name[PDF_TEXT_HENMAXL];
} pdf_text_host_encoding_t;

/* --------------------- Text Module initialization ------------------------- */

/* Initialize Text Module. Warning! Not thread-safe, must be used only once when
 *  the program starts. It will be in charge of detecting currently configured
 *  locale, host encoding... in GNU/Linux and UNIX-like systems
 *  (Mac OS X included) */
pdf_status_t
pdf_text_init(void);


/* --------------------- Text Creation and Destruction ---------------------- */

/* Create new empty text object. Returned type must be checked against NULL. */
pdf_status_t
pdf_text_new (pdf_text_t *text);


/* Destroy (freeing contents) a given text object */
pdf_status_t
pdf_text_destroy (pdf_text_t text);


/* Duplicate text object. Returned type must be checked against NULL.  */
pdf_text_t
pdf_text_dup (const pdf_text_t text);


/* Create new text object from a Host-Encoded string. Status of the conversion
 *  is returned. */
pdf_status_t
pdf_text_new_from_host (const pdf_char_t *str,
                        const pdf_size_t size,
                        const pdf_text_host_encoding_t enc,
                        pdf_text_t *text);


/* Create new text object from a PDF string: either PDFDoc-Encoded string or
 *  UTF-16BE encoded string (BOM mandatory). Status of the conversion is
 *  returned. */
pdf_status_t
pdf_text_new_from_pdf_string (const pdf_char_t *str,
                              const pdf_size_t size,
                              pdf_char_t **remaining_str,
                              pdf_size_t *remaining_length,
                              pdf_text_t *text);


/* Create a new text object from a string of Unicode characters in a given
 *  unicode encoding. Status of the conversion is returned. */
pdf_status_t
pdf_text_new_from_unicode (const pdf_char_t *str,
                           const pdf_size_t size,
                           const enum pdf_text_unicode_encoding_e enc,
                           pdf_text_t *text);


/* Create a new text variable containing the textual representation of a
 *  given integer. Status of the conversion is returned. */
pdf_status_t
pdf_text_new_from_u32 (const pdf_u32_t number,
                       pdf_text_t *text);


/* ------------------------ Text Property Management ------------------------ */

/* Return the country associated with a text variable */
extern INLINE const pdf_char_t *
pdf_text_get_country (const pdf_text_t text);

/* Return the language associated with a text variable */
extern INLINE const pdf_char_t *
pdf_text_get_language (const pdf_text_t text);

/* Associate a text variable (full text) with a country code */
pdf_status_t
pdf_text_set_country (pdf_text_t text,
                      const pdf_char_t *code);

/* Associate a text variable (full text) with a language code */
pdf_status_t
pdf_text_set_language (pdf_text_t text,
                       const pdf_char_t *code);

/* Determine if a given text variable is empty (contains no text) */
pdf_bool_t
pdf_text_empty_p (const pdf_text_t text);

/* Replace a given set of old patterns with a single new pattern */
pdf_status_t
pdf_text_replace_multiple (pdf_text_t text,
                           const pdf_text_t new_pattern,
                           const pdf_text_t *p_old_patterns,
                           const int n_old_patterns);



/* ------------------------ Host Encoding Management ------------------------ */


/* Get Host Encoding configured by the user/system */
pdf_text_host_encoding_t
pdf_text_get_host_encoding(void);


/* Check if a given encoding is available in the system, and return a 
 *  pdf_text_host_encoding_t variable with the host encoding ID if available*/
pdf_status_t
pdf_text_check_host_encoding(const pdf_char_t *encoding_name,
                             pdf_text_host_encoding_t *p_encoding);


/* Get Best Host Encoding to encode the given text object */
pdf_text_host_encoding_t
pdf_text_get_best_encoding (const pdf_text_t text,
                            const pdf_text_host_encoding_t preferred_encoding);



/* ------------------------- Text Content Management ------------------------ */

/* Get the contents of a text variable encoded in a given host encoding */
pdf_status_t
pdf_text_get_host (pdf_char_t **contents,
                   pdf_size_t *length,
                   const pdf_text_t text,
                   const pdf_text_host_encoding_t enc);


/* Get the contents of a text variable encoded in PDFDocEncoding, as a NUL
 *  terminated string */
pdf_status_t
pdf_text_get_pdfdocenc (pdf_char_t **contents,
                        const pdf_text_t text);


/* Get the contents of a text variable encoded in the given UNICODE encoding.
 *  In addition to the specific encoding required, extra options can be set,
 *  in the following way: OPTION1 | OPTION2 | OPTION3 */
pdf_status_t
pdf_text_get_unicode (pdf_char_t **contents,
                      pdf_size_t *length,
                      const pdf_text_t text,
                      const enum pdf_text_unicode_encoding_e enc,
                      const pdf_u32_t options);

/* Get the contents of a text variable in hexadecimal representation as a NUL
 *  terminated string. */
pdf_char_t *
pdf_text_get_hex (const pdf_text_t text,
                  const pdf_char_t delimiter);



/* Set a string encoded with some host encoding. */
pdf_status_t
pdf_text_set_host (pdf_text_t text,
                   const pdf_char_t *str,
                   const pdf_size_t size,
                   const pdf_text_host_encoding_t enc);


/* Set a PDFDocEncoding encoded string. Input data MUST be NUL terminated. */
pdf_status_t
pdf_text_set_pdfdocenc (pdf_text_t text,
                        const pdf_char_t *str);


/* Set a Unicode encoded string. */
pdf_status_t
pdf_text_set_unicode (pdf_text_t text,
                      const pdf_char_t *str,
                      const pdf_size_t size,
                      const enum pdf_text_unicode_encoding_e enc);


/* Concatenate the contents of two text variables. Warning!! Country/Language
 *  information MUST be the same (or inexistent in both elements) if
 *  override_langinfo is NOT set. If override_langinfo is set, the language and
 *  country information of text1 will remain unchanged, whatever the language
 *  and country information of text2 is. */
pdf_status_t
pdf_text_concat (pdf_text_t text1,
                 const pdf_text_t text2,
                 const pdf_bool_t override_langinfo);


/* Replace a fixed pattern in the content of a given text variable */
pdf_status_t
pdf_text_replace (pdf_text_t text,
                  const pdf_text_t new_pattern,
                  const pdf_text_t old_pattern);


/* Replace a fixed ASCII pattern in the content of a given text variable */
pdf_status_t
pdf_text_replace_ascii (pdf_text_t text,
                        const pdf_char_t *new_pattern,
                        const pdf_char_t *old_pattern);

/* Filter the contents of a text variable */
pdf_status_t
pdf_text_filter (pdf_text_t text,
                 const pdf_u32_t filter);


/* ------------------------- Text Comparison -------------------------------- */

/* Compare the contents (character data) of two text variables.
 *  Returns  1 if text1 != text2
 *  Returns  0 if text1 = text2
 */
pdf_i32_t
pdf_text_cmp (const pdf_text_t text1,
              const pdf_text_t text2,
              const pdf_bool_t case_sensitive,
              pdf_status_t *p_ret_code);

/* END PUBLIC */
/* BEGIN PUBLIC */

/* Filesystem item properties */
struct pdf_fsys_item_props_s
{
  pdf_bool_t is_hidden;
  pdf_bool_t is_readable;
  pdf_bool_t is_writable;
  pdf_time_t creation_date;
  pdf_time_t modification_date;
  pdf_u32_t file_size_high;
  pdf_u32_t file_size_low;
  pdf_u32_t folder_size;
};

/* Filesystem */
struct pdf_fsys_impl_s;
struct pdf_fsys_s
{
  struct pdf_fsys_impl_s *implementation; /* Implementation of the
                                           * filesystem */
};

typedef struct pdf_fsys_s *pdf_fsys_t;

/* Open files */
struct pdf_fsys_file_s
{
  pdf_fsys_t fs; /* Underlying filesystem */
  void *data;    /* Private data used by the underlying filesystem
                  * implementation */
};

typedef struct pdf_fsys_file_s *pdf_fsys_file_t;

/* File modes */
enum pdf_fsys_file_mode_e 
  {
    /* First valid element of the enum, useful for iterating */
    PDF_FSYS_OPEN_MODE_FIRST = 0,
    /* Invalid file mode identifier */
    PDF_FSYS_OPEN_MODE_INVALID = PDF_FSYS_OPEN_MODE_FIRST,
    /* The file is opened in read-only mode. The file should exist in
     * the filesystem */
    PDF_FSYS_OPEN_MODE_READ = 1,
    /* The file is opened in write-only mode. The file is truncated to
     * 0 size (any previous contents are lost) if the file exist and
     * it is created if it do not exist */
    PDF_FSYS_OPEN_MODE_WRITE = 2,
    /* The file is opened in read/write mode. The file should exist in
     * the filesystem */
    PDF_FSYS_OPEN_MODE_RW = 3,
    /* Last valid element of the enum, useful for iterating */
    PDF_FSYS_OPEN_MODE_LAST = PDF_FSYS_OPEN_MODE_RW,
    /* Helper to define array size based on this enum */
    PDF_FSYS_OPEN_MODE_MAX,
  };

/* Filesystem implementation callbacks */
typedef pdf_status_t (*pdf_fsys_create_folder_fn_t) (pdf_text_t path_name);
typedef pdf_status_t (*pdf_fsys_get_folder_contents_fn_t) (pdf_text_t path_name,
                                                           pdf_list_t item_list);
typedef pdf_status_t (*pdf_fsys_get_parent_fn_t) (pdf_text_t path_name,
                                                  pdf_text_t parent_path);
typedef pdf_status_t (*pdf_fsys_remove_folder_fn_t) (pdf_text_t path_name);
typedef pdf_size_t (*pdf_fsys_file_read_fn_t) (pdf_fsys_file_t file,
                                               pdf_size_t elem_size,
                                               pdf_size_t elem_count,
                                               void *data);
typedef pdf_size_t (*pdf_fsys_file_write_fn_t) (pdf_fsys_file_t file,
                                                pdf_size_t elem_size,
                                                pdf_size_t elem_count,
                                                void *data);
typedef pdf_status_t (*pdf_fsys_file_flush_fn_t) (pdf_fsys_file_t file);
typedef pdf_status_t (*pdf_fsys_get_item_props_fn_t) (pdf_text_t path_name,
                                                      struct pdf_fsys_item_props_s *props);
typedef pdf_i64_t (*pdf_fsys_get_free_space_fn_t) (pdf_text_t path_name);
typedef pdf_bool_t (*pdf_fsys_item_p_fn_t) (pdf_text_t path_name);
typedef pdf_bool_t (*pdf_fsys_item_readable_p_fn_t) (pdf_text_t path_name);
typedef pdf_bool_t (*pdf_fsys_item_writable_p_fn_t) (pdf_text_t path_name);
typedef pdf_text_t (*pdf_fsys_get_temp_path_name_fn_t) (void);
typedef pdf_bool_t (*pdf_fsys_file_can_set_size_p_fn_t) (pdf_fsys_file_t file,
                                                       pdf_size_t pos);
typedef pdf_status_t (*pdf_fsys_file_open_fn_t) (pdf_text_t path_name,
                                                 enum pdf_fsys_file_mode_e mode,
                                                 pdf_fsys_file_t *p_file);
typedef pdf_size_t (*pdf_fsys_file_get_size_fn_t) (pdf_fsys_file_t file);
typedef pdf_status_t (*pdf_fsys_file_set_size_fn_t) (pdf_fsys_file_t file,
                                                     pdf_size_t pos);
typedef pdf_status_t (*pdf_fsys_file_get_pos_fn_t) (pdf_fsys_file_t file,
                                                    pdf_size_t *pos);
typedef pdf_status_t (*pdf_fsys_file_set_pos_fn_t) (pdf_fsys_file_t file,
                                                    pdf_size_t pos);
typedef enum pdf_fsys_file_mode_e (*pdf_fsys_file_get_mode_fn_t) (pdf_fsys_file_t file);
typedef enum pdf_fsys_file_mode_e (*pdf_fsys_file_set_mode_fn_t) (pdf_fsys_file_t file,
                                                                  enum pdf_fsys_file_mode_e new_mode);
typedef pdf_text_t (*pdf_fsys_file_get_url_fn_t) (pdf_fsys_file_t file);
typedef pdf_bool_t (*pdf_fsys_file_same_p_fn_t) (pdf_fsys_file_t file,
                                                 pdf_text_t path_name);
typedef pdf_status_t (*pdf_fsys_file_request_ria_fn_t) (pdf_fsys_file_t file,
                                                        pdf_size_t offset,
                                                        pdf_size_t count);
typedef pdf_bool_t (*pdf_fsys_file_has_ria_fn_t) (pdf_fsys_file_t file);
typedef pdf_status_t (*pdf_fsys_file_cancel_ria_fn_t) (pdf_fsys_file_t file);
typedef pdf_status_t (*pdf_fsys_file_close_fn_t) (pdf_fsys_file_t file);
typedef pdf_status_t (*pdf_fsys_file_reopen_fn_t) (pdf_fsys_file_t file,
                                                   enum pdf_fsys_file_mode_e mode);

/* Filesystem implementation */
struct pdf_fsys_impl_s
{
  /* Filesystem interface callbacks */
  pdf_fsys_create_folder_fn_t create_folder_fn;
  pdf_fsys_get_folder_contents_fn_t get_folder_contents_fn;
  pdf_fsys_get_parent_fn_t get_parent_fn;
  pdf_fsys_remove_folder_fn_t remove_folder_fn;
  pdf_fsys_get_item_props_fn_t get_item_props_fn;
  pdf_fsys_get_free_space_fn_t get_free_space_fn;
  pdf_fsys_item_p_fn_t item_p_fn;
  pdf_fsys_item_readable_p_fn_t item_readable_p_fn;
  pdf_fsys_item_writable_p_fn_t item_writable_p_fn;
  pdf_fsys_get_temp_path_name_fn_t get_temp_path_name_fn;
  pdf_fsys_file_get_url_fn_t file_get_url_fn;

  /* File interface callbacks */
  pdf_fsys_file_open_fn_t file_open_fn;
  pdf_fsys_file_read_fn_t file_read_fn;
  pdf_fsys_file_write_fn_t file_write_fn;
  pdf_fsys_file_flush_fn_t file_flush_fn;
  pdf_fsys_file_can_set_size_p_fn_t file_can_set_size_p_fn;
  pdf_fsys_file_get_size_fn_t file_get_size_fn;
  pdf_fsys_file_set_size_fn_t file_set_size_fn;
  pdf_fsys_file_get_pos_fn_t file_get_pos_fn;
  pdf_fsys_file_set_pos_fn_t file_set_pos_fn;
  pdf_fsys_file_get_mode_fn_t file_get_mode_fn;
  pdf_fsys_file_set_mode_fn_t file_set_mode_fn;
  pdf_fsys_file_same_p_fn_t file_same_p_fn;
  pdf_fsys_file_request_ria_fn_t file_request_ria_fn;
  pdf_fsys_file_has_ria_fn_t file_has_ria_fn;
  pdf_fsys_file_cancel_ria_fn_t file_cancel_ria_fn;
  pdf_fsys_file_close_fn_t file_close_fn;
  pdf_fsys_file_reopen_fn_t file_reopen_fn;
};

/*
 * Function Declarations
 */

/* Filesystem Interface */

pdf_i64_t pdf_fsys_get_free_space (pdf_fsys_t filesystem,
                                   pdf_text_t path_name);
pdf_status_t pdf_fsys_create_folder (const pdf_fsys_t filesystem,
                                     const pdf_text_t path_name);
pdf_status_t pdf_fsys_get_folder_contents (const pdf_fsys_t filesystem,
                                           const pdf_text_t path_name,
                                           pdf_list_t item_list);
pdf_status_t pdf_fsys_get_parent (const pdf_fsys_t filesystem,
                                  const pdf_text_t path_name,
                                  pdf_text_t parent_path);
pdf_status_t pdf_fsys_remove_folder (const pdf_fsys_t filesystem,
                                     const pdf_text_t path_name);
pdf_status_t pdf_fsys_get_item_props (pdf_fsys_t filesystem,
                                      pdf_text_t path_name,
                                      struct pdf_fsys_item_props_s *item_props);
pdf_status_t pdf_fsys_item_props_to_hash (const struct pdf_fsys_item_props_s item_props,
                                          pdf_hash_t props_hash);
pdf_bool_t pdf_fsys_item_p (pdf_fsys_t filesystem,
                            pdf_text_t path_name);
pdf_bool_t pdf_fsys_item_readable_p (pdf_fsys_t filesystem,
                                     pdf_text_t path_name);
pdf_bool_t pdf_fsys_item_writable_p (pdf_fsys_t filesystem,
                                     pdf_text_t path_name);
pdf_text_t pdf_fsys_get_temp_path_name (pdf_fsys_t filesystem);

/* File Interface */
pdf_status_t pdf_fsys_file_open (const pdf_fsys_t filesystem,
                                 const pdf_text_t path_name,
                                 const enum pdf_fsys_file_mode_e mode,
                                 pdf_fsys_file_t *p_file);

pdf_fsys_t pdf_fsys_file_get_filesystem (pdf_fsys_file_t file);
enum pdf_fsys_file_mode_e pdf_fsys_file_get_mode (pdf_fsys_file_t file);
pdf_text_t pdf_fsys_file_get_url (pdf_fsys_file_t file);
pdf_status_t pdf_fsys_file_set_mode (pdf_fsys_file_t file,
                                                  enum pdf_fsys_file_mode_e new_mode);
pdf_bool_t pdf_fsys_file_same_p (pdf_fsys_file_t file,
                                 pdf_text_t path);
pdf_status_t pdf_fsys_file_get_pos (pdf_fsys_file_t file,
                                    pdf_size_t *pos);
pdf_status_t pdf_fsys_file_set_pos (pdf_fsys_file_t file,
                                    pdf_size_t new_pos);
pdf_bool_t pdf_fsys_file_can_set_size_p (pdf_fsys_file_t file,
                                         pdf_size_t size);
pdf_size_t pdf_fsys_file_get_size (pdf_fsys_file_t file);
pdf_status_t pdf_fsys_file_set_size (pdf_fsys_file_t file,
                                     pdf_size_t size);
pdf_size_t pdf_fsys_file_read (pdf_fsys_file_t file,
                               const pdf_size_t elem_size,
                               const pdf_size_t elem_count,
                               void *data);
pdf_size_t pdf_fsys_file_write (pdf_fsys_file_t file,
                                const pdf_size_t elem_size,
                                const pdf_size_t elem_count,
                                void *data);
pdf_status_t pdf_fsys_file_flush (pdf_fsys_file_t file);
pdf_status_t pdf_fsys_file_request_ria (pdf_fsys_file_t file,
                                        pdf_size_t offset,
                                        pdf_size_t count);
pdf_bool_t pdf_fsys_file_has_ria (pdf_fsys_file_t file);
pdf_status_t pdf_fsys_file_cancel_ria (pdf_fsys_file_t file);
pdf_status_t pdf_fsys_file_close (pdf_fsys_file_t file);
pdf_status_t pdf_fsys_file_reopen (pdf_fsys_file_t file,
                                   enum pdf_fsys_file_mode_e mode);

/* Filesystem Definition Interface */

pdf_fsys_t pdf_fsys_create (struct pdf_fsys_impl_s implementation);
pdf_status_t pdf_fsys_destroy (pdf_fsys_t filesystem);

/* END PUBLIC */
/* BEGIN PUBLIC */

/* Types of filters */
enum pdf_stm_filter_type_e 
{
  PDF_STM_FILTER_NULL = 0,
  PDF_STM_FILTER_RL_ENC,
  PDF_STM_FILTER_RL_DEC,
#if defined(HAVE_LIBZ)
  PDF_STM_FILTER_FLATE_ENC,
  PDF_STM_FILTER_FLATE_DEC,
#endif /* HAVE_LIBZ */
#if defined(HAVE_LIBJBIG2DEC)
  PDF_STM_FILTER_JBIG2_DEC,
#endif /* HAVE_LIBJBIG2DEC */
  PDF_STM_FILTER_AHEX_ENC,
  PDF_STM_FILTER_AHEX_DEC,
  PDF_STM_FILTER_AESV2_ENC,
  PDF_STM_FILTER_AESV2_DEC,
  PDF_STM_FILTER_V2_ENC,
  PDF_STM_FILTER_V2_DEC,
  PDF_STM_FILTER_MD5_ENC
};

/* END PUBLIC */
/* BEGIN PUBLIC */

/* Default size for the stream caches */
#define PDF_STM_DEFAULT_CACHE_SIZE 4096

/* Mode to use when opening a stream */
enum pdf_stm_mode_e
{
  /* Reading stream */
  PDF_STM_READ,
  /* Writing stream */
  PDF_STM_WRITE
};

/* Types of streams */
enum pdf_stm_type_e
{
  PDF_STM_FILE,
  PDF_STM_MEM
};

typedef struct pdf_stm_s *pdf_stm_t;

/* 
 * Stream API
 */

/* Creation and destruction */
pdf_status_t pdf_stm_cfile_new (FILE* file,
				pdf_off_t offset,
				pdf_size_t cache_size,
				enum pdf_stm_mode_e mode,
				pdf_stm_t *stm);
pdf_status_t pdf_stm_file_new (pdf_fsys_file_t file,
                               pdf_off_t offset,
                               pdf_size_t cache_size,
                               enum pdf_stm_mode_e mode,
                               pdf_stm_t *stm);
pdf_status_t pdf_stm_mem_new (pdf_char_t *buffer,
                              pdf_size_t size,
                              pdf_size_t cache_size,
                              enum pdf_stm_mode_e mode,
                              pdf_stm_t *stm);
pdf_status_t pdf_stm_destroy (pdf_stm_t stm);

/* Reading and writing data */
pdf_status_t pdf_stm_read (pdf_stm_t stm,
                           pdf_char_t *buf,
                           pdf_size_t bytes,
                           pdf_size_t *read_bytes);
pdf_status_t pdf_stm_write (pdf_stm_t stm,
                            pdf_char_t *buf,
                            pdf_size_t bytes,
                            pdf_size_t *written_bytes);
pdf_status_t pdf_stm_read_char (pdf_stm_t stm, pdf_char_t *c);
pdf_status_t pdf_stm_peek_char (pdf_stm_t stm, pdf_char_t *c);
pdf_status_t pdf_stm_flush (pdf_stm_t stm,
                            pdf_bool_t finish_p,
                            pdf_size_t *flushed_bytes);

/* Positioning */

pdf_off_t pdf_stm_seek (pdf_stm_t stm,
                        pdf_off_t pos);
pdf_off_t pdf_stm_tell (pdf_stm_t stm);


/* Management of the filter chain */

pdf_status_t pdf_stm_install_filter (pdf_stm_t stm,
                                     enum pdf_stm_filter_type_e filter_type,
                                     pdf_hash_t filter_params);
/* END PUBLIC */
/* BEGIN PUBLIC */

pdf_status_t
pdf_hash_add_text (pdf_hash_t table, const char *key, const pdf_text_t *elt);

pdf_status_t
pdf_hash_get_text (pdf_hash_t table, const char *key, pdf_text_t *elt);

pdf_status_t
pdf_hash_add_time (pdf_hash_t table, const char *key, const pdf_time_t *elt);

pdf_status_t
pdf_hash_get_time (pdf_hash_t table, const char *key, pdf_time_t *elt);

pdf_status_t
pdf_hash_add_list (pdf_hash_t table, const char *key, const pdf_list_t *elt);

pdf_status_t
pdf_hash_get_list (pdf_hash_t table, const char *key, pdf_list_t *elt);

pdf_status_t
pdf_hash_add_hash (pdf_hash_t table, const char *key, const pdf_hash_t *elt);

pdf_status_t
pdf_hash_get_hash (pdf_hash_t table, const char *key, pdf_hash_t *elt);

pdf_status_t
pdf_hash_add_stm (pdf_hash_t table, const char *key, const pdf_stm_t *elt);

pdf_status_t
pdf_hash_get_stm (pdf_hash_t table, const char *key, pdf_stm_t *elt);

pdf_status_t
pdf_hash_add_size (pdf_hash_t table, const char *key, const pdf_size_t elt);

pdf_status_t
pdf_hash_get_size (pdf_hash_t table, const char *key, pdf_size_t *elt);

pdf_status_t
pdf_hash_add_string (pdf_hash_t table, const char *key, const pdf_char_t *elt);

pdf_status_t
pdf_hash_get_string (pdf_hash_t table, const char *key, pdf_char_t **elt);


/* END PUBLIC */
/* BEGIN PUBLIC */

enum pdf_crypt_md_algo_e
{
    PDF_CRYPT_MD_MD5
};

enum pdf_crypt_cipher_algo_e
{
  PDF_CRYPT_CIPHER_ALGO_AESV2,
  PDF_CRYPT_CIPHER_ALGO_V2
};

typedef struct pdf_crypt_cipher_s *pdf_crypt_cipher_t;
typedef struct pdf_crypt_md_s *pdf_crypt_md_t;

/* END PUBLIC */
/* BEGIN PUBLIC */

pdf_status_t pdf_crypt_init (void);

pdf_status_t pdf_crypt_nonce (pdf_char_t * buffer, pdf_size_t size);

pdf_status_t pdf_crypt_cipher_new (enum pdf_crypt_cipher_algo_e algorithm,
				   pdf_crypt_cipher_t *cipher);

pdf_status_t pdf_crypt_cipher_setkey (pdf_crypt_cipher_t cipher,
				      pdf_char_t *key,
				      pdf_size_t size);

pdf_status_t pdf_crypt_cipher_encrypt (pdf_crypt_cipher_t cipher,
				       pdf_char_t *out,
				       pdf_size_t out_size,
				       pdf_char_t *in,
				       pdf_size_t in_size,
				       pdf_size_t *result_size);

pdf_status_t pdf_crypt_cipher_decrypt (pdf_crypt_cipher_t cipher,
				       pdf_char_t *out,
				       pdf_size_t out_size,
				       pdf_char_t *in,
				       pdf_size_t in_size,
				       pdf_size_t *result_size);

pdf_status_t pdf_crypt_cipher_destroy (pdf_crypt_cipher_t cipher);


pdf_status_t pdf_crypt_md_new (enum pdf_crypt_md_algo_e algo, pdf_crypt_md_t *md);

pdf_status_t pdf_crypt_md_write (pdf_crypt_md_t md,
                                 pdf_char_t *in,  pdf_size_t in_size);

pdf_status_t pdf_crypt_md_read (pdf_crypt_md_t md,
				pdf_char_t *out, pdf_size_t out_size);


pdf_status_t pdf_crypt_md_destroy (pdf_crypt_md_t hd);



/* END PUBLIC */
/* BEGIN PUBLIC */

typedef struct pdf_fp_func_s *pdf_fp_func_t;

/* Interal size of the type 4 functions stack */
#define PDF_FP_FUNC_TYPE4_STACK_SIZE 100

#define PDF_FP_FUNC_TYPE4_TRUE  (1.202056903159594285399738162)
#define PDF_FP_FUNC_TYPE4_FALSE (-15116315767.09215686274509804)

typedef union
{
  struct {
    pdf_status_t status;
    pdf_i32_t op;
    pdf_i32_t stack_size;
    double stack[PDF_FP_FUNC_TYPE4_STACK_SIZE];
  } type4;
} pdf_fp_func_debug_t;

/* END PUBLIC */
/* BEGIN PUBLIC */

pdf_status_t pdf_fp_func_0_new (pdf_u32_t m,
                                pdf_u32_t n,
                                const pdf_real_t domain[],
                                const pdf_real_t range[],
                                pdf_u32_t size[],
                                pdf_u32_t bps,
                                pdf_u32_t order,
                                const pdf_real_t encode[],
                                const pdf_real_t decode[],
                                pdf_char_t *samples,
                                pdf_size_t samples_size,
                                pdf_fp_func_t *function);

pdf_status_t pdf_fp_func_2_new (pdf_u32_t m,
                                pdf_u32_t n,
                                const pdf_real_t domain[],
                                const pdf_real_t range[],
                                pdf_real_t N,
                                pdf_real_t c0[],
                                pdf_real_t c1[],
                                pdf_fp_func_t *function);

pdf_status_t pdf_fp_func_3_new (pdf_u32_t m,
                                pdf_u32_t n,
                                const pdf_real_t domain[],
                                const pdf_real_t range[],
                                pdf_u32_t k,
                                pdf_fp_func_t *functions,
                                pdf_real_t bounds[],
                                const pdf_u32_t encode[],
                                pdf_fp_func_t *function);

pdf_status_t pdf_fp_func_4_new (pdf_u32_t m,
                                pdf_u32_t n,
                                pdf_real_t domain[],
                                pdf_real_t range[],
                                pdf_char_t *code,
                                pdf_size_t code_size,
                                pdf_size_t *error_at,
                                pdf_fp_func_t *function);

pdf_status_t pdf_fp_func_eval (pdf_fp_func_t function,
                               const pdf_real_t in[],
                               pdf_real_t out[],
                               pdf_fp_func_debug_t * debug);

pdf_status_t pdf_fp_func_get_bounds (const pdf_fp_func_t function,
                                     pdf_i32_t *in_dimensions,
                                     pdf_i32_t *out_dimensions);

pdf_status_t pdf_fp_func_destroy (pdf_fp_func_t function);

/* END PUBLIC */
#ifdef __cplusplus
} // extern "C"
#endif
#endif /* !PDF_H */
/* end of pdf.h */
